# (for rpm-2.3.9 and later)
# Predefined Macros:
# PACKAGE_VERSION
# PACKAGE_RELEASE
# 
# User-Defined Macros:
# %define <name> <expansion>
%define FIMVER      1.0
%define ICNLSTFIL   fvwm2-icons.lst
%define BITMAPDIR   /usr/X11R6/include/bitmaps
%define PIXMAPDIR   /usr/X11R6/include/pixmaps
%define ListBitmaps ls -1 icons/ | grep -v 'README' | grep -v '\.xpm$'
%define ListPixmaps ls -1 icons/ | grep '\.xpm$'
Summary: Feeble Virtual Window Manager
Name: fvwm2
Version: 2.0.46
Release: 3
Packager: Jim Knoble <jmknoble@pobox.com>
Copyright: GPL
Group: X11/Window Managers
Icon: fvwm.gif
URL: http://www.hpc.uh.edu/fvwm/
Source0: ftp://ftp.hpc.uh.edu/pub/fvwm/version-2/fvwm-%{PACKAGE_VERSION}.tar.gz
#Source1: system.fvwmrc
#Source2: ftp://ftp.cs.arizona.edu/people/bradym/FvwmIconMan-%{FIMVER}.tar.gz
#Source3: ftp://ftp.uow.edu.au/pub/software/fvwmwharf.tar.Z
Patch0: fvwm2-2.0.46-config.patch
Patch1: fvwm2-2.0.46-mansuffix.patch
Patch2: FvwmIconMan-1.0-fix.patch
Patch3: fvwm2-2.0.46-FvwmConsole.patch
Patch4: fvwm2-2.0.46-FvwmTaskBar.patch
Patch5: fvwm2-2.0.46-FvwmWharf.patch
Patch6: FvwmWharf-fix-swallow.patch
BuildRoot: /tmp/fvwm2-build

%package utils
Summary: Utilities for use with fvwm2
Group: X11/Window Managers

%package icons
Summary: Icons and pixmaps for use with fvwm2
Group: X11/Window Managers

%description
Fvwm is a small, fast, and very flexible window manager.  It can be
configured to look like Motif, and has a useful `button bar'.  This one
can use m4 or cpp to preprocess its configuration file.

%description utils
Fvwm is a small, fast, and very flexible window manager.  It can be
configured to look like Motif, and has a useful `button bar'.  This one
can use m4 or cpp to preprocess its configuration file.

These utilities can be useful in conjunction with fvwm.

%description icons
Fvwm is a small, fast, and very flexible window manager.  It can be
configured to look like Motif, and has a useful `button bar'.  This one
can use m4 or cpp to preprocess its configuration file.

These icons can be useful in conjunction with fvwm.

%changelog
* Sun Sep 07 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.46-3]
  - Released for public consumption.

* Sun Sep 07 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.46-3jmk]
  - Use BuildRoot to avoid munging existing fvwm2 installation when
    installing modules.  Suggested by Manoj Kasichainula
    <manojk@io.com> (thanks, Manoj!).

* Thu Aug 21 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.46-2]
  - Released for public consumption.

* Wed Aug 20 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.46-2jmk]
  - Added scripts in utils/ directory to %doc directory.
  - Use subpackaging scheme based on that of Trond Eivind Glomsrd
    <teg@pvv.ntnu.no> from his fvwm-2.0.45-1 package (takk skal du ha,
    Trond!):
      - Include xpmroot in separate utilities package (fvwmrc_convert
        goes in %doc directory of main package, along with other
        scripts there).
      - Include pixmaps and icons in separate package.
      - Modules ought to stay with main fvwm2 package: who's to say
        which ones ought to to be included in the main package and
        which ones ought not to?
  - Move old /usr/X11R6/lib/X11/fvwm2/ dir before installing, to make
    sure we only get the modules we built in the package.

* Wed Aug 20 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.46-1]
  - changed package release number for general consumption.

* Wed Aug 20 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.46-1jmk]
  - updated to fvwm-2.0.46.
  - use PACKAGE_VERSION and other macros.
  - fvwm-2.0.46 uses FvwmIconMan-1.0, which is current version;
    commented out installation of FvwmIconMan into fvwm source tree.
  - fvwm-2.0.46 uses FvwmWharf; commented out installation of FvwmWharf
    into fvwm source tree.
  - FvwmTaskBar and FvwmWharf appear to have some problems; don't build
    them for now.

* Wed Jul 16 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.45-10jmk]
  - Added FvwmWharf module.

* Tue Jun 10 1997 Jim Knoble <jmknoble@pobox.com>
  [fvwm2-2.0.45-9jmk]
  - Make sure system.fvwmrc is installed in /etc/X11/fvwm2
    (fvwm2-*-config.patch).
  - Make sure man pages for modules don't conflict with like-named man
    pages from fvwm95 or fvwm-1.xx (use MANSUFFIX in Imakefile; see
    fvwm2-*-mansuffix.patch).
  - Use FvwmIconMan-0.9.9a.
  - FvwmIconMan appears to have a few problems with function
    declarations; fixed with FvwmIconMan-*-fix.patch.
  - Added FvwmConsole to package; needed to make sure it found readline
    header files.

%prep
%setup -n fvwm-%{PACKAGE_VERSION}
#(cd modules; rm -rf FvwmIconMan; tar -zxvf $RPM_SOURCE_DIR/FvwmIconMan-%{FIMVER}.tar.gz)
#(cd modules; tar -zxvf $RPM_SOURCE_DIR/fvwmwharf.tar.Z)
#(cd modules; chmod -R u+rwX,go+rX,go-w *; chown -R root.root *)

function Replace() {
    local fil="$1"
    local sep="$2"
    local old="$3"
    local new="$4"
    mv -f $fil $fil~
    cat $fil~ | sed -e "s${sep}${old}${sep}${new}${sep}g" >$fil
}

%patch0 -p0 -b .origcnf
%patch1 -p0 -b .origman
%patch2 -p0 -b .origFIM
Replace modules/FvwmIconMan/readconfig.c / GetNextToken GetNextCommaToken
%patch3 -p0 -b .origFCon
ln -s ../extras/FvwmConsole modules/FvwmConsole
#%patch4 -p0 -b .origFTB
#ln -s ../extras/FvwmTaskBar modules/FvwmTaskBar
#%patch5 -p0 -b .origFW
#ln -s ../extras/FvwmWharf modules/FvwmWharf
#%patch6 -p0 -b .origFWfix

## Build a list of icon filenames
 cat /dev/null > %{ICNLSTFIL}
 %{ListBitmaps} | sed -e 's@^\(.*\)$@%{BITMAPDIR}/\1@g' >> %{ICNLSTFIL}
 %{ListPixmaps} | sed -e 's@^\(.*\)$@%{PIXMAPDIR}/\1@g' >> %{ICNLSTFIL}
##

%build
export PATH=$PATH:/usr/X11R6/bin
xmkmf -a
make

%install
#function Backup() {
#    local xtn=".rpmorig"
#    local tst="$1"
#    shift
#    for fil in "$@"; do
#        if [ ${tst} ${fil} ]; then 
#            if [ ${tst} ${fil}${xtn} ]; then 
#                rm -rf ${fil}
#            else
#                mv -f ${fil} ${fil}${xtn}
#            fi
#        fi
#    done
#}
#function Link() {
#    local filnam="$1"
#    local lnknam="$2"
#    Backup -e ${lnknam}
#    ln -s ${filnam} ${lnknam}
#}
function CheckBuildRoot() {
    # do a few sanity checks on the BuildRoot
    # to make sure we don't damage a system
    case "${RPM_BUILD_ROOT}" in
        /|/bin|/boot|/dev|/etc|/home|/lib|/mnt|/root|/sbin|/tmp|/usr|/var)
            echo "Yikes!  Don't use '${RPM_BUILD_ROOT}' for a BuildRoot!"
            echo "The BuildRoot gets deleted when this package is rebuilt;"
            echo "something like '/tmp/fvwm2-build' is a better choice."
            return 1
            ;;
        *)  return 0
            ;;
    esac
}
function CleanBuildRoot() {
    if CheckBuildRoot; then
        rm -rf "${RPM_BUILD_ROOT}"
    else
        exit 1
    fi
}

#Backup /usr/X11R6/lib/X11/fvwm2
#make install
CleanBuildRoot
mkdir -p "${RPM_BUILD_ROOT}"
make DESTDIR="${RPM_BUILD_ROOT}" install
( cd ${RPM_BUILD_ROOT}/etc/X11/fvwm2/; mv -f system.fvwmrc system.fvwm2rc )
make DESTDIR="${RPM_BUILD_ROOT}" install.man

## Install icons and pixmaps
 mkdir -p ${RPM_BUILD_ROOT}%{BITMAPDIR}
 %{ListBitmaps} | sed -e 's@^\(.*\)$@icons/\1@g' | \
   xargs -i install -m 0644 -o root -g root '{}' ${RPM_BUILD_ROOT}%{BITMAPDIR}/
 mkdir -p ${RPM_BUILD_ROOT}%{PIXMAPDIR}
 %{ListPixmaps} | sed -e 's@^\(.*\)$@icons/\1@g' | \
   xargs -i install -m 0644 -o root -g root '{}' ${RPM_BUILD_ROOT}%{PIXMAPDIR}/
##

%clean
function CheckBuildRoot() {
    # do a few sanity checks on the BuildRoot
    # to make sure we don't damage a system
    case "${RPM_BUILD_ROOT}" in
        /|/bin|/boot|/dev|/etc|/home|/lib|/mnt|/root|/sbin|/tmp|/usr|/var)
            echo "Yikes!  Don't use '${RPM_BUILD_ROOT}' for a BuildRoot!"
            echo "The BuildRoot gets deleted when this package is rebuilt;"
            echo "something like '/tmp/fvwm2-build' is a better choice."
            return 1
            ;;
        *)  return 0
            ;;
    esac
}
function CleanBuildRoot() {
    if CheckBuildRoot; then
        rm -rf "${RPM_BUILD_ROOT}"
    else
        exit 1
    fi
}
CleanBuildRoot

%files
%doc ChangeLog BUGS FAQ README TO-DO 
%doc sample.fvwmrc/system.fvwm2rc-sample-1
%doc sample.fvwmrc/system.fvwm2rc-sample-2
%doc sample.fvwmrc/decor_examples
%doc utils

%dir /etc/X11/fvwm2
%config /etc/X11/fvwm2/system.fvwm2rc

/usr/X11R6/bin/fvwm2
/usr/X11R6/lib/X11/fvwm2
/usr/X11R6/man/man1/fvwm2.1x

/usr/X11R6/man/man1/FvwmAudio.2.1fvwm
/usr/X11R6/man/man1/FvwmAuto.2.1fvwm
/usr/X11R6/man/man1/FvwmBacker.2.1fvwm
/usr/X11R6/man/man1/FvwmBanner.2.1fvwm
/usr/X11R6/man/man1/FvwmButtons.2.1fvwm
/usr/X11R6/man/man1/FvwmCascade.2.1fvwm
/usr/X11R6/man/man1/FvwmConsole.2.1fvwm
/usr/X11R6/man/man1/FvwmCpp.2.1fvwm
/usr/X11R6/man/man1/FvwmForm.2.1fvwm
/usr/X11R6/man/man1/FvwmIconBox.2.1fvwm
/usr/X11R6/man/man1/FvwmIconMan.2.1fvwm
/usr/X11R6/man/man1/FvwmIdent.2.1fvwm
/usr/X11R6/man/man1/FvwmM4.2.1fvwm
/usr/X11R6/man/man1/FvwmPager.2.1fvwm
/usr/X11R6/man/man1/FvwmSave.2.1fvwm
/usr/X11R6/man/man1/FvwmSaveDesk.2.1fvwm
/usr/X11R6/man/man1/FvwmScroll.2.1fvwm
/usr/X11R6/man/man1/FvwmTalk.2.1fvwm
#/usr/X11R6/man/man1/FvwmTaskBar.2.1fvwm
/usr/X11R6/man/man1/FvwmTile.2.1fvwm
#/usr/X11R6/man/man1/FvwmWharf.2.1fvwm
/usr/X11R6/man/man1/FvwmWinList.2.1fvwm

%files utils
/usr/X11R6/bin/xpmroot
/usr/X11R6/man/man1/xpmroot.1x

%files icons -f %{ICNLSTFIL}
%doc icons/README.mini
